<!DOCTYPE html>
<html>
  <head>
    <%block name="lo_head">
      <meta charset="utf-8" />
      <meta name="viewport" content="width=device-width, initial-scale=1.0 , user-scalable=no" />

      <%block name="lo_paper_meta"/>

      <title id="lo-head-title">
        <%block name="lo_head_title"/>
      </title>

      <%block name="lo_head_script">

        <script src="/static/jquery/jquery-2.1.0.min.js"></script>
        <script src="/static/bootstrap/js/bootstrap.min.js"></script>
        <!-- Bookshelf support -->
        <script src="/static/crypt/md5.js"></script>
        <!-- Nested Sortable -->
        <script src="/static/nestedSortable/jquery-ui-1.10.3.custom.min.js"></script>
        <script src="/static/nestedSortable/jquery.mjs.nestedSortable.js"></script><!-- jqueryui only with sortable component-->
        <script src="/static/URI/URI.js"></script>
        <script src="/static/shortcut/shortcut.js"></script>
        <script src="/static/cookie/cookie.js"></script>
        <!-- Rangy -->
        <script src="/static/rangy/rangy-core.js"></script>
        <script src="/static/rangy/rangy-serializer.js"></script>
        <!-- strftime -->
        <script src="/static/strftime/strftime.js"></script>
        <!-- google-diff-match-patch -->
        <script src="/static/diff-match-patch/diff_match_patch.js"></script>
        <!-- lightbox -->
        <script src="/static/lightbox/js/lightbox.js"></script>
        <link rel="stylesheet" href="/static/lightbox/css/lightbox.css" type="text/css" />

      </%block>

      <link rel="stylesheet" href="/static/bootstrap/css/bootstrap.min.css" type="text/css" />
      <link rel="stylesheet" href="/static/lonote/css/lonote.css" type="text/css" />
      <link rel="stylesheet" href="/static/custom/custom.css" type="text/css" />
      <%block name="lo_head_append"/>

    </%block>
  </head>

  <body>
    <%block name="lo_aside">
      <aside>
        <nav id="lo-nav" role="navigation" class="navbar navbar-default navbar-fixed-top">
          <div id="lo-nav-header">
            <%block name="lo_nav_header">
              <a id="lo-nav-title" class="navbar-brand" data-toggle="modal" tooltip data-title="${_('Paper Menu')}" data-placement="right" href="#lo-papermenu-modal">${_('No Title')}</a>
            </%block>
          </div>

          <div id="lo-nav-tools" class="navbar-btn">
            <%block name="lo_nav_tools"/>
          </div>
        </nav>

        <div id="lo-data">
          <%block name="lo_data"/>
          <%block name="lo_papermenu_modal"/>
        </div>

      </aside>
    </%block>

    <article id="lo-article">
      <%block name="lo_article">

        <div id="lo-article-content" class="lo-content"><%block name="lo_article_content"/></div>

        <%block name="lo_article_footer">
          <footer id="lo-article-footer" class="text-center">
            <p class=""> - 
            % if config['SITEINFO'].get('site_name'):
              % if config['SITEINFO'].get('site_info_url'):
                <strong><a href="${config['SITEINFO'].get('site_info_url')}" target="_blank" style="color: rgb(51,51,51); text-decoration: none;">${config['SITEINFO'].get('site_name') | h}</a></strong>
              % else:
                <strong>${config['SITEINFO'].get('site_name') | h}</strong>
              % endif
              - <br/> -
            % endif
            <a href="${info.homepage}" target="_blank" style="color: inherit; text-decoration: none;">${_('LoNote Personal Notebook') | h}</a> ${info.version | h} -</p>
          </footer>
        </%block>
      </%block>
    </article>

    <%block name="lo_base_script">
      <!-- library -->
      <script>
        // selection control
        function selSave(){
          rangy.init();
          var sel = rangy.getSelection();
          var root_elem = document.querySelector("#lo-article-content");
          try {
            var sel_str = rangy.serializeSelection(
              sel, true, root_elem);
            if (!sel_str) {return;}
            localStorage['selection_of_' + location.pathname] = sel_str;
              // 以上 omitChecksum 設 true 是因為有些會在顯示時改變
              // DOM 結構的 library 會造成干擾，造成 checksum 不正確。
              // 如 mathjax。
          } catch (err) {
            localStorage.removeItem(
              'selection_of_' + location.pathname);
          }
        };

        function selRestore(){
          var sel_str = localStorage['selection_of_' + location.pathname];
          var root_elem = document.querySelector("#lo-article-content");
          if (sel_str != undefined && sel_str != null && sel_str != '' && rangy.canDeserializeSelection(sel_str, root_elem)) {
            try {
              rangy.deserializeSelection(sel_str, root_elem);
              $('#lo-article-content').focus();
            }
            catch (err){}
          }
        };
      </script>

      <script>
        $(document).ready(function(){
          $('[tooltip]').tooltip();
          $('[popover]').popover();
        });
        // $('#lo-data input[type=text]')
        //   .on('click', function(){ this.select(); })

        function lo_article_scroll_save(){
          var scroll_Y = $(window).scrollTop();
          localStorage['lo_article_scroll_Y' + location.pathname ] = scroll_Y;
        };
        function lo_article_scroll_restore(){
          try{
            var scroll_Y = parseInt(localStorage['lo_article_scroll_Y' + location.pathname], 10);
          }catch(e){return}
          $(window).scrollTop(scroll_Y); //嘗試滾動
          if($(window).scrollTop() < scroll_Y){ // 補充滾動
            $(window).one('load', lo_article_scroll_restore);
          }
        };
        // 掛載
        $(document).ready(lo_article_scroll_restore);
        $(window).on('beforeunload', lo_article_scroll_save);
      </script>

      <script>
        shortcut.add('F1',function() {
          location.pathname = '/start.html';
        });
        shortcut.add('F4',function() {
          window.open('/hotkey.html');
        });
        shortcut.add('F8',function() {
          location.pathname = '/bookshelf.html'
        });
      </script>

      <!-- Time -->
      <script>
        // 字串變 date
        function str_to_date(str){
          var fixed_str = str.replace(/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})\.\d{6}([+-]\d{2})(\d{2})/, function($0,$1,$2,$3,$4,$5,$6,$7,$8){return $1 + '-' + $2 + '-' + $3 + 'T' + $4 + ':' + $5 + ':' + $6 + $7 + ':' + $8});
          var d = new Date(fixed_str);
          return d;
        };

        $('.lo-time').each(function(index, elem){
          var d = str_to_date( $(elem).attr('time') );
          $(elem).text(d.strftime('%m/%d'));
        });
      </script>
    </%block>

    <%block name="append_script">
    </%block>

  </body>
</html>

