<%!
  from lonote.im3 import Paper
  import hashlib
%>

<%def name="editnav_item(book, paper, md5hex)">
  <a id="a-${md5hex}" bs-tooltip data-title="${paper.desc | h}" href="/edit/${book.bid}/${paper.pid}/${Paper.default_sid}.html">${paper.name | h}</a>
</%def>

<%def name="editnav(book, paper)">
  <% pid_children = book.pid_children(paper.pid) %>
  <% # Avoid unsafe bid #
    string = book.bid + paper.pid
    md5hex = hashlib.md5(string.encode('utf8')).hexdigest()
  %>
  % if pid_children:
    <li>
      <input type="checkbox" id="checkbox-${md5hex}">
      <label for="checkbox-${md5hex}">
        <span class="lo-bsm-expand glyphicon glyphicon-chevron-down"></span>
        <span class="lo-bsm-collapse glyphicon glyphicon-chevron-right"></span>
      </label>
      ${editnav_item(book, paper, md5hex)}
      <ul>
      % for child_pid in pid_children:
        ${editnav(book, book.paper(child_pid))}
      % endfor
      </ul>
    </li>
  % else:
    <li>${editnav_item(book, paper, md5hex)}</li>
  % endif
</%def>

<%def name="editnav_all(bookshelf)">
  <div id="lo-bookshelf">
    <% books = bookshelf.values() %>
    % if books:
      <ul class="sortable">
        % for book in books:
          ${editnav(book, book.paper(book.rootpid))}
        % endfor
      </ul>
    % else:
      <div class="alert alert-info">
        <p><strong>${_("No book found!") | h}</strong></p>
        <p>${_("Please create or upload some book first") + " ♬" | h}</p>
      </div>
    % endif
  </div>
</%def>

${editnav_all(bs)}
