<%!
  import lonote.im3
%>

## meta
<%def name="papermeta(book, paper, sid)">
  <input hidden id="lo-book-name" value="${book.name}">
</%def>

## header: lo_nav_header
<%def name="modal_edit_papermenu(book, paper, sid)">
  <!-- Paper Menu Modal -->
  <div class="modal" id="lo-papermenu-modal" tabindex="-1" role="dialog" aria-labelledby="lo-papermenu-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-papermenu-modal-title" class="modal-title">
              ${_('Paper Menu') | h}
          </h4>
        </div>
        <div id="lo-papermenu-modal-body" class="modal-body">

    % if 'e' in a_type:

      <!-- name -->
      <div class="row">
        <div class="col-xs-8">
          <input id="lo-article-name-input" type="text" class="form-control input-lg" placeholder="${_('Paper Name') | h}" value="${paper.name | h}" tooltip data-title="${_('Paper Name') | h}" data-placement="auto">
        </div>
        % if sid == type(paper).default_sid:
          <!-- kill this page -->
          <div class="col-xs-4">
            % if book.rootpid != paper.pid:
              <button id="lo-article-paper-delete-input" type="button" class="btn btn-lg btn-danger pull-right" tooltip data-title="${ _('Be careful! It will remove this paper entirely. Include all sections, resources and children papers.') | h}" data-placement="auto" tabindex="-1"><span class="glyphicon glyphicon-trash"></span> ${_('Delete') | h}</button>
            % endif
          </div>
        % endif
      </div>
      

      <br/>
      <!-- desc -->
      <div class="input-group">
        <span class="input-group-addon">${_('Description')}</span>
        <input id="lo-article-desc-input" type="text" class="form-control" placeholder="${_('Paper Description') | h}" value="${paper.desc | h}" tooltip data-title="${_('Paper Description') | h}" data-placement="auto">
      </div>

      <hr/>

      <!-- sections -->
      <div class="input-group">
        <span class="input-group-addon" tooltip data-title="${_('Current Section ID') | h}" data-placement="auto">${sid}</span>
        <input id="lo-article-section-desc-input" type="text" class="form-control" placeholder="${_('Section Description') | h}" value="${paper.sections.data_meta(sid).get('desc') | h}" tooltip data-title="${_('Section Description') | h}" data-placement="auto">
          <%
            if sid == paper.default_sid:
              del_tooltip = _( 'Cannot delete the default section!' )
              del_disable = 'disabled="disabled"'
            else:
              del_tooltip = _( 'Delete this section!' )
              del_disable = ''
          %>
        <span id="lo-sid-group" class="input-group-btn">
          <button id="lo-article-section-delete-input" class="btn btn-danger" type="button" tooltip data-title="${ del_tooltip | h}" data-placement="auto" data-container="#lo-sid-group" ${del_disable}><span class="glyphicon glyphicon-trash"></span> ${_('Delete') | h}</button>
        </span>
      </div>
      <br/>

    % endif

    <!-- mtime ctime -->
    <input disabled id="lo-article-section-ctime-input" type="datetime" value="${paper.sections.data_meta(sid).get('ctime') | h}" style="display: none;">
    <input disabled id="lo-article-section-mtime-input" type="datetime" value="${paper.sections.data_meta(sid).get('mtime') | h}" style="display: none;">
    <div class="input-group input-group-sm">
      <span class="input-group-addon" tooltip data-title="${_('Section Created Time') | h}" data-placement="auto">${_('Created')}</span>
      <input disabled id="lo-article-section-ctime-input-display" type="datetime" class="form-control" value="${paper.sections.data_meta(sid).get('ctime') | h}">
      <span class="input-group-addon" tooltip data-title="${_('Section Modified Time') | h}" data-placement="auto">${_('Modified')}</span>
      <input disabled id="lo-article-section-mtime-input-display" type="datetime" class="form-control" value="${paper.sections.data_meta(sid).get('mtime') | h}">
    </div>

    % if 'e' in a_type:

      <hr/>

      <!-- new section -->
      <div class="input-group">
        <input id="lo-article-new-sid-input" type="text" class="form-control" placeholder="${_('New section ID') | h}" value="" tooltip data-title="${_('Input a non-exists section ID and must a valid filename. e.g., "talk", "backup".') | h}" data-placement="auto">
        <span id="lo-new-sid-group" class="input-group-btn">
          <button id="lo-article-new-sid-copy-button" class="btn btn-default" type="button" tooltip data-title="${_('Copy content to new section') | h}" data-placement="auto" data-container="#lo-new-sid-group"><span class="glyphicon glyphicon-share-alt"></span> ${_('Duplicate')}</button>
          <button id="lo-article-new-sid-create-button" class="btn btn-primary" type="button" tooltip data-title="${_('Create the new section!') | h}" data-placement="auto" data-container="#lo-new-sid-group"><span class="glyphicon glyphicon-leaf"></span> ${_('Create')}</button>
        </span>
      </div>

    % endif


        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <script>
    function lo_time_display_update(){
      var d = str_to_date($('#lo-article-section-ctime-input').val());
      $('#lo-article-section-ctime-input-display').val(
        d.strftime('%Y-%m-%d (%a) %H:%M:%S'));
      var d = str_to_date($('#lo-article-section-mtime-input').val());
      $('#lo-article-section-mtime-input-display').val(
        d.strftime('%Y-%m-%d (%a) %H:%M:%S'));
    };

    // 上繳 meta 訊息，並將 selector 打亮
    function article_meta_put(data, selector){
      var basetime = $('#lo-article-section-mtime-input').val();
      data.basetime = basetime;
      var jqxhr = $.ajax({
        url: location.pathname,
        type: 'PUT',
        data: data
      })
        .done(function(data) {
          $(selector).parent().animate({'opacity': '0.0'}, 'fast');
          $(selector).parent().addClass('has-success');
          $(selector).parent().removeClass('has-error');
          $(selector).parent().animate({'opacity': '1.0'}, 'fast');
          $('#lo-article-section-mtime-input').val(data);
          lo_time_display_update();
        }) 
        .fail(function(jqXHR, textStatus, errorThrown){
          $(selector).parent().addClass('has-error');
          $(selector).parent().removeClass('has-success');
          alert(jqXHR.responseText);
        });
      return jqxhr;
    };

    // change paper name
    var an_selector = "#lo-article-name-input"
    $( an_selector ).change(function() {
      if ($(an_selector).val() == ''){
        $(an_selector).val($('#lo-nav-title').text());
        return;
      }
      var jqxhr = article_meta_put( { paper_name: $(an_selector).val() },
        an_selector);
      jqxhr.done(function(){
        $('#lo-nav-title').html($(an_selector).val());
        % if sid != lonote.im3.Paper.default_sid:
          var head_title = $(an_selector).val() + ' (${sid | h}) - ' +\
            $('#lo-book-name').val();
        % else:
          var head_title = $(an_selector).val() + ' - ' +\
            $('#lo-book-name').val();
        % endif
        $('#lo-head-title').html( head_title );
      });
    });
    // change paper desc
    var ad_selector = "#lo-article-desc-input"
    $( ad_selector ).change(function() {
      var jqxhr = article_meta_put( { paper_desc: $(ad_selector).val() },
        ad_selector);
      jqxhr.done(function(){
        $('#lo-nav-title')
          .attr('data-content', $(ad_selector).val());
      });
    });
    // change section desc
    var asd_selector = "#lo-article-section-desc-input";
    $( asd_selector ).change(function() {
      var jqxhr = article_meta_put({section_desc: $(asd_selector).val()},
        asd_selector);
      jqxhr.done(function(){
        $('#lo-nav-sid')
          .attr('data-content', $(asd_selector).val());
      });
    });
    // delete section
    var asdi_selector = "#lo-article-section-delete-input";
    $(asdi_selector).click(function(){
      lo_article_content_put(); // save first
      if (confirm('${_("Really delete this SECTION ?") | h}')){
        $.ajax({
          url: window.location.pathname,
          type: 'DELETE',
          async: false
        }).done(function(data){
          location = data;
        });
      }
    });
    // new_section
    function lo_new_section(copy){
      var sid_input = $("#lo-article-new-sid-input");
      var new_sid = sid_input.val();
      if (new_sid == '' || new_sid.match(/[/\\:*?"<>|]{1,240}/)) {
        sid_input.parent().addClass('has-error');
        return
      }
      var path = URI(location.pathname).filename(new_sid + '.html');
      var content = '';
      if (copy){
        var content = $('#lo-article-content').html();
      }
      data = {'new_section': content};
      $.ajax({
        url: path,
        type: 'PUT',
        data: data,
        async: false
      }).done(function(){
        location = path;
      }).fail(function(){
        sid_input.parent().addClass('has-error');
      });
    };
    $("#lo-article-new-sid-create-button")
      .click(function(){lo_new_section(false)});
    $("#lo-article-new-sid-copy-button")
      .click(function(){lo_new_section(true)});
    $("#lo-article-new-sid-input").keypress(function(){
      $(window).keydown(function(event){
        if(event.keyCode == 13) {
          event.preventDefault();
          lo_new_section(false);
          return false;
        }
      });
    });

    $(document).ready(function(){
      lo_time_display_update();
      shortcut.add('F2',function() {
        $('#lo-papermenu-modal').modal('toggle');
      });
      shortcut.add('Ctrl+Alt+S',function() {
        $('#lo-papermenu-modal').modal('show');
        $('#lo-article-new-sid-input').focus();
      });
      $('#lo-papermenu-modal').on('show.bs.modal', function(){
        $('.modal').modal('hide');
        selSave();
      });
      $('#lo-papermenu-modal').on('shown.bs.modal', function(){
        $('#lo-article-name-input').focus();
      });
      $('#lo-papermenu-modal').on('hidden.bs.modal', function(){
        selRestore();
      });
    });
    function delete_paper_book_done(){
      // alert("${_('Delete complete!')}");
      location = '/bookshelf.html';
    };
    // delete paper
    var lad_selector = "#lo-article-paper-delete-input";
    $(lad_selector).click(function(){
      lo_article_content_put(); // save first
      $.ajax({
        url: "/func/paperinfo/${book.bid | h}/${paper.pid | h}",
        type: 'GET',
        async: false
      }).done(function(data){
        if (confirm('${_("Really delete this PAPER (and children papers) ?") | h}\n\n' + data)){
          $.ajax({
            url: URI(location.pathname).directory(),
            type: 'DELETE',
            async: false
          }).done(delete_paper_book_done);
        }
      });
    });
  </script>
</%def>

## btn: save
<%def name="btn_save()">
  <button id="lo-save-btn" type="button" class="btn btn-default" onclick="lo_article_content_put('diff', true);" tooltip data-title="${_('Saved.')}" data-placement="bottom" data-container="body"><span class="glyphicon glyphicon-ok"></span></button>
</%def>

<%def name="script_save()">
  <script>
    // 將頁面上的所有路徑相對化
    function path_relative(){
      // 傳入一個連結，如果可能則傳出相對連結，否則傳出原值
      var local = location.origin + location.pathname;
      var localuri = new URI(local);
      function torel(link){
        var uri = new URI(link);
        if(uri.protocol() == localuri.protocol() && uri.host() == localuri.host()){ link = uri.relativeTo(local).readable(); }
        return link;
      };

      $('#lo-article-content a').attr('href',
          function(){return torel(this.href)});
      $('#lo-article-content img').attr('src',
          function(){return torel(this.src)});
      //$('#lo-article-content object').attr('data', function(){alert($(this).html());return torel(this.data)});
    };

    // save content
    var lo_article_content_changed = false;
    var lo_article_content_old = null; // need init after ready
    var lo_article_content_old_md5 = null;
    var lo_article_content_observer = null;
    var dmp = new diff_match_patch;
    function lo_article_content_put(mode, force){
      mode = mode || 'diff';
      force = force || false;

      if (lo_article_content_changed || force){ // 需要更新
        lo_article_content_changed = false;
        $('#lo-save-btn').html('<span class="glyphicon glyphicon-time"></span>').tooltip('destroy').tooltip({'title': "${_('Now saving...') | h}"});
        path_relative();
        lo_article_content_observer.takeRecords();
        var html = $('#lo-article-content').html();
        var patch = dmp.patch_make(lo_article_content_old, html);
        var patch_text = dmp.patch_toText(patch);
        try{
          var basetime = $('#lo-article-section-mtime-input').val();
          var response = undefined;

          function done(data){
            lo_article_content_old = html;
            lo_article_content_old_md5 = hex_md5(html);
            $('#lo-article-section-mtime-input').val(data);
            lo_time_display_update();
            $('#lo-save-btn').html('<span class="glyphicon glyphicon-ok"></span>').tooltip('destroy').tooltip({'title': "${_('Saved') | h}"}).tooltip('hide');
          };
          function fail(jqXHR, textStatus, errorThrown){
            lo_article_content_changed = true;
            if (jqXHR.responseText === undefined){
              $('#lo-save-btn').html('<span class="glyphicon glyphicon-info-sign"></span>').tooltip('destroy').tooltip({'title': "${_('Disconnected: Save Failed! Please re-connect to the server.') | h}"}).tooltip('show');
            } else if (jqXHR.status == 403){ // MD5 Not match
              lo_article_content_put('full', true);
            }else {
              $('#lo-save-btn').html('<span class="glyphicon glyphicon-info-sign"></span>').tooltip('destroy').tooltip({'title': jqXHR.responseText}).tooltip('show');
            }
            response = jqXHR.responseText;
          };

          if (mode == 'diff'){
            var data = {patch_text: patch_text,
              basetime: basetime,
              basemd5: lo_article_content_old_md5};
            $.ajax({
              url: location.pathname,
              type: 'PUT',
              data: data,
              async: false
            }).done(done).fail(fail);
          } else if(mode == 'full'){
            var data = {content: html,
              basetime: basetime};
            $.ajax({
              url: location.pathname,
              type: 'PUT',
              data: data,
              async: false
            }).done(done).fail(fail);
          } else {
            alert('mode value not correct!');
          }
          return response;
        } catch(e){
          lo_article_content_changed = true;
          $('#lo-save-btn').html('<span class="glyphicon glyphicon-info-sign"></span>').tooltip('destroy').tooltip({'title': "${_('Unexpect Error: Save Failed! Maybe disconnect. Please re-connect to the server.') | h}"}).tooltip('show');
          return e;
        }
      }
    };

    function save_change_init(){
      lo_article_content_old = $('#lo-article-content').html();
      lo_article_content_old_md5 = hex_md5(lo_article_content_old);

      var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;
      var target = document.querySelector('#lo-article-content');
      lo_article_content_observer = new MutationObserver(
          function(mutations) {
            mutations.forEach(function(m){
              if(m.target != target || m.attributeName != "contenteditable"){
                lo_article_content_changed = true;
                $('#lo-save-btn').html('<span class="glyphicon glyphicon-cloud-upload"></span>').tooltip('destroy').tooltip({'title': "${_('Not saved yet. Click here to save.') | h}"});
              }
            });
      });
      var config = { attributes: true, childList: true, characterData: true, subtree: true };
      lo_article_content_observer.observe(target, config);

      // other
      setInterval(lo_article_content_put, 60000);
      $(window).on('beforeunload', function(){return lo_article_content_put();});
    };

    % if 'e' in a_type:
      $(document).ready(function(){
        save_change_init();
      });
    % endif
  </script>
</%def>

## btn: search
<%def name="btn_search()">
  <button type="button" class="btn btn-default" tooltip data-title="${_('Search')}" data-placement="bottom" data-container="body" data-toggle="modal" href="#lo-search-modal"><span class="glyphicon glyphicon-search"></span></button>
</%def>

<%def name="modal_search()">
  <!-- Bookshelf Modal -->
  <div class="modal" id="lo-search-modal" tabindex="-1" role="dialog" aria-labelledby="lo-search-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-search-modal-title" class="modal-title">${_('Search')}</h4>
        </div>
        <div id="lo-search-modal-body" class="modal-body">

          <div class="input-group" style="max-width: 400px; margin-left: auto; margin-right: auto;">
            <input id="lo-search-input" type="search" class="form-control" placeholder="${_('Type your keywords.') | h}">
            <span class="input-group-btn">
              <button id="lo-search-submit" class="btn btn-primary" type="button"><span class="glyphicon glyphicon-search"></span> ${_('Search')}</button>
            </span>
          </div>
          <div class="text-center">
            <button type="button" class="btn btn-link btn-xs" id="lo-search-hint-trigger" ><span class="glyphicon glyphicon-question-sign"></span> ${_("How to Search?") | h}</button>
          </div>
          <div id="lo-search-hint" style="display: none;">
            <table class="table table-hover table-condensed">
              <caption>${_("Supported Fields") | h}</caption>
              <thead>
                <tr><th>${_('Field') | h}</th><th>${_('Description') | h}</th></tr>
              </thead>
              <tbody>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('pname');"><code>pname</code></button></td><td>${_('Paper Name') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('pdesc');"><code>pdesc</code></button></td><td>${_('Paper Description') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('text');"><code>text</code></button></td><td>${_('Article Content') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('sid');"><code>sid</code></button></td><td>${_('Section ID') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('sdesc');"><code>sdesc</code></button></td><td>${_('Section Description') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('bid');"><code>bid</code></button></td><td>${_('Book ID') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('mtime');"><code>mtime</code></button></td><td>${_('Modified Time') | h}</td></tr>
                <tr><td><button class="btn btn-default btn-xs" onclick="lo_search_insert('ctime');"><code>ctime</code></button></td><td>${_('Created Time') | h}</td></tr>
              </tbody>
            </table>
            <hr/>
            <p>${_("Search Examples:") | h}</p>
            <pre>apple pie
NOT (school OR universe)
pname:house sid:main
bid:testbook*
ctime:'-1 week to now'</pre>
            <p class="text-right small"><a href="http://pythonhosted.org/Whoosh/querylang.html" target="_blank"><span class="glyphicon glyphicon-question-sign"></span> ${_("About the query language.") | h}</a></p>
          </div>
          <script>
            $('#lo-search-hint-trigger').popover({
              html: true,
              placement: "bottom",
              trigger: "click",
              title: "${_('Hint of Search') | h}",
              content: function() {
                return $('#lo-search-hint').html();
              }
            }).on('click', function(){$('#lo-search-input').focus();});
            function lo_search_insert(text){
              var $input = $('#lo-search-input');
              var ori_val = $input.val();
              var new_val = ori_val.trim() + ' ' + text + ':';
              $input.val(new_val.trim());
              $input.focus();
              return false;
            };
          </script>
          <div id="lo-search-result"></div>

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <!-- Search Modal operation-->
  <script>
    function get_result(page){
      $('#lo-search-hint-trigger').popover('hide'); // close hint popover
      var page = typeof page !== 'undefined' ? page : 1; // default: 1
      $('#lo-search-result').html(
          '<div style="max-width: 768px; margin-left: auto; margin-right: auto;"><div class="progress progress-striped active">'+
            '<div class="progress-bar progress-bar-info"  role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%">'+
              '<span class="glyphicon glyphicon-search"></span><span>${_('Searching...')}</span>'+
            '</div>'+
          '</div>');
      var key = URI.encodeQuery($('#lo-search-input').val());
      $('#lo-search-result').load('/data-search.html?key=' + key + '&page=' + page,
          function (responseText, textStatus, req) {
            if(req.status != 200) {
              $('#lo-search-result').html('<div class="alert alert-danger">${_('Search Failed! Please wait a few seconds and try again...') | h}</div>');
            } else {
              $('[search-result-tooltip]').tooltip(); // tooltip
            }
          });
    };
    function index_update_request_async(){
      $.ajax({
        url: '/func/index-update',
        type: 'POST'
      });
    };
    $('#lo-search-submit').on('click', function(){get_result();});
    $('#lo-search-input').on('keypress', function(e){
      if(e.keyCode == 13){ get_result(); }
    });
    
    // call by result entry
    function lo_search_to_bsm(hashid) {
      var $li = lo_bsm_get_$li(hashid);
      lo_bsm_expand_current($li);
      var $bsm = $('#lo-bookshelf-modal');
      $bsm.modal('show');
      var t = lo_bsm_get_best_position($li);
      $bsm.scrollTop(t);
      var $icon = $('<span class="label label-warning" style="vertical-align: middle; position: relative; left: 110px; opacity: 0.3;"><span style="position: static;" class="glyphicon glyphicon-arrow-left"></span> <span style="position: static;" class="glyphicon glyphicon-search"></span></span>');
      var $a = $li.find('> a');
      $a.append($icon);
      $a.css('font-weight', 'bold');
      $icon.animate({left: "10px", opacity: "1"}, 600);
      // $li.fadeOut(500).fadeIn(500).fadeOut(500).fadeIn(500);
      $bsm.one('hide.bs.modal', function(){$icon.remove(); $a.css('font-weight', ''); });
    };

    shortcut.add('Alt+W',function() {
      $('#lo-search-modal').modal('toggle');
    });

    var lo_search_scroll_Y = 1;
    $('#lo-search-modal')
      .on('show.bs.modal', function(){
        index_update_request_async(); // update index
        $('.modal').modal('hide');
        selSave();
      })
      .on('shown.bs.modal', function(){
        var $input = $('#lo-search-input');
        ## if ($input.val() == ''){
        $input.focus();
        ## }
        $('#lo-search-modal').scrollTop(lo_search_scroll_Y);
      })
      .on('hidden.bs.modal', function(){
        selRestore();
        })
      .on('hide.bs.modal', function(){
        var tmp_y = $('#lo-search-modal').scrollTop();
        if (tmp_y){lo_search_scroll_Y = tmp_y;}
        })
  </script>

</%def>

## btn: bookshelf
<%def name="btn_bookshelf()">
  <button type="button" class="btn btn-default" tooltip data-title="${_('Bookshelf')}" data-placement="bottom" data-container="body" data-toggle="modal" href="#lo-bookshelf-modal"><span class="glyphicon glyphicon-book"></span></button>
</%def>

<%def name="modal_bookshelf()">
  <!-- Bookshelf Modal -->
  <div class="modal" id="lo-bookshelf-modal" tabindex="-1" role="dialog" aria-labelledby="lo-bookshelf-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-bookshelf-modal-title" class="modal-title">${_('Bookshelf')}</h4>
        </div>
        <div id="lo-bookshelf-modal-body" class="modal-body">
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" onclick="lo_bsm_collapse_all(); lo_bsm_expand_current();" >${_('Collapse')}</button>
          ## <button type="button" class="btn btn-default" onclick="lo_bsm_expand_all();" >${_('Expand All')}</button>
          <button type="button" class="btn btn-default" onclick="lo_bsm_reload();" >${_('Reload')}</button>
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <!-- Bookshelf Modal operation-->
  <script>
    function lo_bsm_scroll_save(){
      var display = $('#lo-bookshelf-modal').css('display');
      if (display != 'none'){
        var scroll_Y = $('#lo-bookshelf-modal').scrollTop();
        localStorage['lo_bs_scroll_Y'] = scroll_Y;
      }
    };
    function lo_bsm_scroll_restore(){
      try{
        var scroll_Y = parseInt(localStorage['lo_bs_scroll_Y'], 10);
      }catch(e){return}
      $('#lo-bookshelf-modal').scrollTop(scroll_Y);
    };
    function lo_bsm_checked_save(){
      var lo_bs_checked = new Array();
      $('#lo-bookshelf-modal-body input:checked').each(function(){
        lo_bs_checked.push($(this).attr('id'));
      });
      localStorage['lo_bs_checked'] = JSON.stringify(lo_bs_checked);
    };
    function lo_bsm_checked_restore(){
      try{
        var lo_bs_checked = JSON.parse(localStorage['lo_bs_checked']);
      }catch(e){return}
      for (x in lo_bs_checked){
        var query = '#lo-bookshelf-modal-body input[id=' + lo_bs_checked[x] + ']';
        $(query).prop('checked', true);
      };
    };
    function lo_bsm_get_$li(hashid){
      var query = '#a-'+hashid;
      return $(query).parent('li');
    }
    function lo_bsm_get_$current(){
      % if paper:
        var uri = new URI(location.pathname);
        var path = uri.filename('${type(paper).default_sid}' + '.html').pathname(true);
        var $target = $('#lo-bookshelf-modal a[href="'+path+'"]')
          .parent('li');
        return $target;
      % else:
        return null;
      % endif
    };
    function lo_bsm_get_$parents($li){
      if ($li){
        return $li.parents('li');
      } else {
        return null;
      }
    };
    function lo_bsm_load(){
      var $bsm_body = $('#lo-bookshelf-modal-body'); // inject here
      $bsm_body.html(
        '<div class="progress progress-striped active">' +
        '  <div class="progress-bar"  role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%">' +
        '    <span>Loading...</span>' +
        '  </div>' +
        '</div>');
      // get new data
      var lo_bsm_cache = localStorage.getItem('lo-bsm-cache');
      var url = '/data-bookshelf.html';
      var lo_bsm_cache_obj = {};
      if (lo_bsm_cache == null){}
      else {
        lo_bsm_cache_obj = JSON.parse(lo_bsm_cache);
        url = url + '?cached_md5=' + lo_bsm_cache_obj.md5;
      }
      $.ajax({
        url: url,
      }).done( function( data, textStatus, jqXHR ){
          if (data == ''){ // use cache
            $bsm_body.html(lo_bsm_cache_obj.content);
          } else { // get new data
            $bsm_body.html(data);
            // update cache
            lo_bsm_cache_obj.content = data;
            lo_bsm_cache_obj.md5 = hex_md5(data);
            var cache_json = JSON.stringify(lo_bsm_cache_obj);
            localStorage.setItem('lo-bsm-cache', cache_json);
          }
          // post-processing
          lo_bsm_checked_restore();
          lo_bsm_scroll_restore();
          $('[bs-tooltip]').tooltip({animation: false});
          % if paper:
            // Highlight current paper in bookshelf
            var $cur = lo_bsm_get_$current();
            $cur.find('> a').append($('<span class="label label-success pull-right"><span style="position: static;" class="glyphicon glyphicon-pencil"></span></span>'));
            // Highlight current paper parents in bookshelf
            var $par = lo_bsm_get_$parents($cur);
            $par.find('> a').append($('<span class="label label-warning pull-right"><span style="position: static;" class="glyphicon glyphicon-folder-open"></span></span>')).css('font-weight', 'bold');
          % endif
      }).fail(function( jqXHR, textStatus, errorThrown ){
          if (jqXHR.responseText === undefined){
            $bsm_body.html(
            '<div class="alert alert-danger"><span class="glyphicon glyphicon-exclamation-sign"></span> ${_('<b>LoNote server down:</b> can not fetch the bookshelf.')}</div>'
            );
          }
      });
      ## $('#lo-bookshelf-modal-body')
      ##   .load('/data-bookshelf.html',
      ##     function(){
      ##       lo_bsm_checked_restore();
      ##       lo_bsm_scroll_restore();
      ##       $('[bs-tooltip]').tooltip({animation: false});
      ##       // Highlight current paper in bookshelf
      ##       % if paper:
      ##         var $cur = lo_bsm_get_$current();
      ##         $cur.find('> a').append($('<span class="label label-success pull-right"><span style="position: static;" class="glyphicon glyphicon-pencil"></span></span>'));
      ##         // Highlight current paper parents in bookshelf
      ##         var $par = lo_bsm_get_$parents($cur);
      ##         $par.find('> a').append($('<span class="label label-warning pull-right"><span style="position: static;" class="glyphicon glyphicon-folder-open"></span></span>')).css('font-weight', 'bold');
      ##       % endif
      ##     });
    };
    function lo_bsm_reload(){
      lo_bsm_scroll_save();
      lo_bsm_checked_save();
      lo_bsm_load();
    };
    ## function lo_bsm_expand_all(){
    ##   var $all = $('#lo-bookshelf-modal-body input[type=checkbox]');
    ##   $all.prop('checked', true);
    ## };
    function lo_bsm_collapse_all(){
      var $all = $('#lo-bookshelf-modal-body input[type=checkbox]');
      $all.prop('checked', false);
    };
    function lo_bsm_expand_current($li){
      $li = typeof $li !== 'undefined' ? $li : lo_bsm_get_$current();

      $li.find('> input').prop('checked', true);
      var $par = lo_bsm_get_$parents($li);
      $par.find('> input').prop('checked', true);
    };
    function lo_bsm_get_best_position($li){
      var $bsm = $('#lo-bookshelf-modal');
      $li = typeof $li !== 'undefined' ? $li : lo_bsm_get_$current();
      if (!$li){
        return $bsm.scrollTop(); // not change
      }

      var total_height = $(window).height();
      var base_top = $('#lo-bookshelf-modal').offset().top;
      var target_scroll = 0;

      function get_target_scroll($li){
        var $par = $li.parent('ul').parent('li');
        var cur_scroll = $li.offset().top + $bsm.scrollTop();
        if ($par.length > 0){
          if ($par.is(':visible') && $li.is(':visible')){
            var par_scroll = $par.offset().top + $bsm.scrollTop();
            if (cur_scroll - par_scroll < total_height * 0.33){
              return par_scroll - base_top;
            } else {
              return cur_scroll - base_top;
            }
          } else {
            return get_target_scroll($par);
          };
        } else {
          return cur_scroll - base_top;
        };
      }
      var target_scroll = get_target_scroll($li)

      return target_scroll - total_height * 0.2
    };
    function lo_bsm_event_init(){
      $('#lo-bookshelf-modal')
        .on('hide.bs.modal', lo_bsm_scroll_save)
        .on('shown.bs.modal', lo_bsm_scroll_restore)
        .on('show.bs.modal', function(){
          $('.modal').modal('hide');
          selSave();
        })
        .on('hidden.bs.modal', function(){
          selRestore();
        })
        .on('keypress', function(e){
          e.preventDefault();
          if ( e.charCode == 113 ){ // q
            $('#lo-bookshelf-modal').animate({ scrollTop: 0 }, 200);
          } else if (e.charCode == 97) { // a
            var t = lo_bsm_get_best_position();
            $('#lo-bookshelf-modal').animate({ scrollTop: t }, 200);
          } else if (e.charCode == 122){ // z
            var t = $('#lo-bookshelf-modal')[0].scrollHeight - $(window).height();
            $('#lo-bookshelf-modal').animate({ scrollTop: t }, 200);
          }
        });
      $(window)
        .on('beforeunload', lo_bsm_scroll_save)
        .on('beforeunload', lo_bsm_checked_save);
      shortcut.add('Alt+Q',function() {
        $('#lo-bookshelf-modal').modal('toggle');
      });
    }

    // lonote bookshelf modal loaded
    lo_bsm_load();
    lo_bsm_event_init();
  </script>

</%def>

## btn: index of content
<%def name="btn_ioc()">
  <button type="button" class="btn btn-default" tooltip data-title="${_('Index of Contents')}" data-placement="bottom" data-container="body" data-toggle="modal" href="#lo-ioc-modal"><span class="glyphicon glyphicon-list"></span></button>
</%def>

<%def name="modal_ioc()">
  <!-- Index of Contents Modal -->
  <div class="modal" id="lo-ioc-modal" tabindex="-1" role="dialog" aria-labelledby="lo-ioc-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-ioc-modal-title" class="modal-title">${_('Index of Contents')}</h4>
        </div>
        <div id="lo-ioc-modal-body" class="modal-body">
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <!-- Index of Contents Operation-->
  <script>
    var lo_article_heading_selector = '#lo-article-content h1, #lo-article-content h2, #lo-article-content h3, #lo-article-content h4, #lo-article-content h5, #lo-article-content h6';

    function lo_ioc_scroll_to(index){
      var elem = $(lo_article_heading_selector).get(index);
      var jelem = $(elem);
      $('html, body').animate({
        scrollTop: jelem.offset().top - $('#lo-nav').outerHeight() - 5
      }, 500);
    };

    function lo_get_viewport(){
      var $win = $(window);

      var viewport = {
        top : $win.scrollTop() + 50, // +50 for nav bar
        left : $win.scrollLeft()
      };
      viewport.right = viewport.left + $win.width();
      viewport.bottom = viewport.top + $win.height();

      return viewport;
    };

    function lo_in_viewport($elem){
      var viewport = lo_get_viewport();

      var bounds = $elem.offset();
      bounds.right = bounds.left + $elem.outerWidth();
      bounds.bottom = bounds.top + $elem.outerHeight();

      return (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));
    };

    function lo_ioc_renew(){
      var marked = false;
      var vp = lo_get_viewport();

      var heading_dom_array = $(lo_article_heading_selector)
        .map(function(index, domElement){return domElement;});
      if (heading_dom_array.length == 0) {
        $('#lo-ioc-modal-body').html(
          '<div class="alert alert-info">'+
            '<p><strong>${_("No heading found!") | h}</strong></p>'+
            '<p>${_("Please create some heading first!") + " ♬"  | h}</p>'+
          '</div>');
        return
      }

      function level_num(dom){
        switch(dom.tagName.toLowerCase()){
          case 'h1':
            return 1;
          case 'h2':
            return 2;
          case 'h3':
            return 3;
          case 'h4':
            return 4;
          case 'h5':
            return 5;
          case 'h6':
            return 6;
        }
      };

      function indent(index, target_level, dom, current_level, jqElem){
        var need_in = target_level - current_level;
        if (need_in == 0){
          function scroll_func(index){
            return function(){
              $('#lo-ioc-modal').modal('hide');
              lo_ioc_scroll_to(index);
            };
          };

          var $li_content = $('<span>').text($(dom).text());

          var item = $('<li>');

          // 計算當前 Heading 是否是用戶正在瀏覽的段落
          if (!marked) {
            if (index + 1 < heading_dom_array.length){
              var next_dom = heading_dom_array[index + 1];
              var scroll_gap = 10;
              if (vp.top >= $(dom).offset().top - scroll_gap && vp.top < $(next_dom).offset().top - scroll_gap) {
                item.append('<span class="label label-success pull-right"><span class="glyphicon glyphicon-pencil"></span></span> ');
                $li_content.css('font-weight', 'bold');
                marked = true;
              }
            }
          }

          item.append($li_content);
          item.addClass('heading_item')
            .addClass('heading_level_' + target_level)
            .on('click', scroll_func(index));

          jqElem.append(item);
          return jqElem
        } else if (need_in > 0){
          var new_jqElem = $('<ol>')
            .addClass('lo-ioc-h' + target_level);
          jqElem.append(new_jqElem);
          return indent(index, target_level, dom, current_level + 1, new_jqElem);
        } else {
          var new_jqElem = jqElem.parent();
          return indent(index, target_level, dom, current_level - 1, new_jqElem);
        }
      };

      function heading_list_gen(){
        var root = $('<div id="lo-ioc">');
        var jqElem = root;
        var current_level = 0;
        for (var i = 0; i < heading_dom_array.length; i++){
          var dom = heading_dom_array[i];
          level = level_num(dom);
          jqElem = indent(i, level, dom, current_level, jqElem);
          current_level = level;
        }
        return root;
      };

      heading_list = heading_list_gen();
      $('#lo-ioc-modal-body').html(heading_list);
    };

    var lo_ioc_scroll_Y = 0;
    function lo_ioc_scroll_save(){
      var display = $('#lo-ioc-modal').css('display');
      if (display != 'none'){
        lo_ioc_scroll_Y = $('#lo-ioc-modal').scrollTop();
      }
    };
    function lo_ioc_scroll_restore(){
      $('#lo-ioc-modal').scrollTop(lo_ioc_scroll_Y);
    };

    function lo_ioc_mount(){
      $('#lo-ioc-modal').on('show.bs.modal', function(){
        $('.modal').modal('hide')
        selSave();
        lo_ioc_renew();
      });
      $('#lo-ioc-modal').on('shown.bs.modal', function(){
        lo_ioc_scroll_restore();
      });
      $('#lo-ioc-modal').on('hide.bs.modal', function(){
        lo_ioc_scroll_save();
      });
      $('#lo-ioc-modal').on('hidden.bs.modal', function(){
        selRestore();
      });

      shortcut.add('Alt+A',function() {
        $('#lo-ioc-modal').modal('toggle')
      });
    };

    lo_ioc_mount();
  </script>
</%def>

## btn: resource
## <%def name="btn_resource()">
##   <button type="button" class="btn btn-default" tooltip data-title="${_('Resource')}" data-placement="bottom" data-container="body" data-toggle="modal" href="#lo-resource-modal"><span class="glyphicon glyphicon-inbox"></span></button>
## </%def>

<%def name="modal_resource()">
  <!-- Resource Modal -->

  <%def name="resource_items()">
    <%
      def is_image(fname):
        return fname.rsplit('.')[-1] in {'jpg',
          'jpeg', 'gif', 'png', 'svg', 'bmp', 'webp'}

      img_rids = [ rid for rid in paper.resources.ids if is_image(rid) ]
      img_rids.sort()
      other_rids = [ rid for rid in paper.resources.ids if not is_image(rid) ]
      other_rids.sort()
    %>

    % if not paper.resources.ids:
    <div class="alert alert-info">
      <p><strong>${_('No Resource in Here!')}</strong></p>
      <p>${_('You can insert some resource in this page') + ' ♬'}</p>
    </div>
    % endif

    <%def name="type_label(type)">
      % if type == 'emb':
        <span class="label label-primary">${_('emb')}</span>
      % elif type == 'att':
        <span class="label label-warning">${_('att')}</span>
      % endif
    </%def>

    <ul class="list-group">
      % for rid in other_rids:
        ## <% desc = paper.resources.data_meta(rid).get('desc') %>
        <li class="list-group-item">
          ${type_label(paper.resources.data_meta(rid).get('res_type'))}
          <a href="${rid}">${rid}</a>
          % if 'e' in a_type:
            <button type="button" class="btn btn-danger btn-xs pull-right" onclick="resource_delete('${rid}', this)"><span class="glyphicon glyphicon-remove-sign"></span></button>
          % endif
        </li>
      % endfor
      % for rid in img_rids:
        ## <% desc = paper.resources.data_meta(rid).get('desc') %>
        <li class="list-group-item">
          <div class="media">
            <a class="pull-left" href="${rid}" data-lightbox="resource-image" data-title="${rid}" style="width: 64px; height: 64px;">
              <img class="media-object" style="max-width: 64px; max-height: 64px;" src="${rid}" alt="${rid}">
            </a>
            <div class="media-body">
              <p>
              ${type_label(paper.resources.data_meta(rid).get('res_type'))}
              <a href="${rid}" target="_blank">${rid}</a>
              % if 'e' in a_type:
                <button type="button" class="btn btn-danger btn-xs pull-right" onclick="resource_delete('${rid}', this)"><span class="glyphicon glyphicon-remove-sign"></span></button>
              % endif
              </p>
            </div>
          </div>
        </li>
      % endfor
    </ul>


  </%def>

  <div class="modal" id="lo-resource-modal" tabindex="-1" role="dialog" aria-labelledby="lo-resource-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-resource-modal-title" class="modal-title">${_('Resource')}</h4>
        </div>
        <div id="lo-resource-modal-body" class="modal-body">
          ${resource_items()}

          % if 'e' in a_type:
            <hr/>

            <div class="panel panel-default">
              <div class="panel-heading">
                <h3 class="panel-title">${_('Special Resource Operation') | h }</h3>
              </div>
              <div class="panel-body">
                <div class="btn-group btn-group-justified">
                  <a id="lo-resource-imgemb" type="button" class="btn btn-primary" tooltip data-title="${_('Import and convert all External Images to paper resources.') | h}" data-placement="auto" data-container="#lo-resource-modal-body"><span class="glyphicon glyphicon-import"></span></a>
                  <a id="lo-resource-clearunused" type="button" class="btn btn-danger" tooltip data-title="${_('Remove all unused (of all sections) embedded type resources.') | h}" data-placement="auto" data-container="#lo-resource-modal-body"><span class="glyphicon glyphicon-trash"></span></a>
                </div>
              </div>
            </div>
          % endif

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <script>
    $('#lo-resource-modal').on('show.bs.modal', function(){
      selSave();
    });
    $('#lo-resource-modal').on('hidden.bs.modal', function(){
      selRestore();
    });
    // 刪掉指定 url 的 resource
    function resource_delete(rid, ethis){
      var uri = URI(rid);

      if(confirm('"'+rid+'" - ' + '${_('Really delete ?')}' )){
        $.ajax({
          url: uri.path(),
          type: 'DELETE'
        }).done(function(){
            var e = $(ethis).parents('li');
            e.animate({
              opacity: '0.0',
              left: '400px',
            },
            500,
            function(){e.remove()});
          });
      }
    };

    $('#lo-resource-imgemb').on('click', function(){
      if (confirm("${_('Really Make External Images Embedded ?') | h}")){
        lo_article_content_put();
        $.ajax({
          url: '/func/imgemb',
          type: 'POST',
          data: {bid: '${book.bid}', pid: '${paper.pid}', sid:'${sid}'},
          async: false
        }).done(function(){
          location.reload();
        });
      }
    });
    $('#lo-resource-clearunused').on('click', function(){
      if (confirm("${_('Really Delete Unused Embedded ?') | h}")){
        lo_article_content_put();
        $.ajax({
          url: '/func/clearunused',
          type: 'POST',
          data: {bid: '${book.bid}', pid: '${paper.pid}'},
          async: false
        }).done(function(){
          location.reload();
        });
      }
    });

    //$(document).ready()
  </script>
</%def>

## btn: configure_menu

<%def name="configure_menu_newpaper_item()">
  <%
    newpaper_disable = ''
    newpaper_href = 'href="#"'
    if paper.pid == book.rootpid:
      newpaper_disable = 'class="disabled"'
      newpaper_href = ''
  %>
  <li tooltip data-title="${_('Create a new paper.')}" data-placement="left" data-container="body" ${ newpaper_disable } ><a id="lo-config-newpaper" ${newpaper_href}><span class="glyphicon glyphicon-plus"></span> ${_('New Paper')}</a></li>
  <li tooltip data-title="${_('Create a new paper under this paper.')}" data-placement="left" data-container="body"><a id="lo-config-newchildpaper" href="#"><span class="glyphicon glyphicon-arrow-right"></span> ${_('New Child Paper')}</a></li>
</%def>

<%def name="configure_menu_newpaper_script()">
  <script>
    % if paper.pid != book.rootpid:
      function lo_newpaper(){
        $.ajax({
          url: location.pathname,
          type: 'POST',
          data: {new_append: 'new_append'}
        }).done(function(data){
            location = data;
          });
      };
      $(document).ready(function(){
        $("#lo-config-newpaper").click(lo_newpaper);
      });
      shortcut.add('Alt+N', lo_newpaper);
    % endif
    function lo_newchildpaper(){
      $.ajax({
        url: location.pathname,
        type: 'POST',
        data: {new_child: 'new_child'}
      }).done(function(data){
          location = data;
        });
    };
    $(document).ready(function(){
      $("#lo-config-newchildpaper").click(lo_newchildpaper);
    });

    shortcut.add('Ctrl+Alt+N', lo_newchildpaper);
  </script>
</%def>

<%def name="books_control_modal()">
  <div class="modal" id="lo-books-control-modal" tabindex="-1" role="dialog" aria-labelledby="lo-books-control-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-books-control-modal-title" class="modal-title">${_('Books Management') | h}</h4>
        </div>
        <div id="lo-books-control-modal-body" class="modal-body">

  <div class="panel-group" id="lo-books-control-pg">

    <div class="panel panel-default">
      <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-books-control-pg" data-target="#lo-books-control-dad">
        <h3 class="panel-title">${_('Download and Delete')}</h3>
      </div>
      <div id="lo-books-control-dad" class="panel-collapse collapse in">
        <div class="panel-body">
          % if len(bs):
            <ul class="list-group">
              % for bid in bs.keys():
                % if book is not UNDEFINED and book.bid == bid:
                <li class="list-group-item list-group-item-success lo-current-book-tag">
                % else:
                <li class="list-group-item">
                % endif
                  <span class="pull-right">
                    <a type="button" class="btn btn-primary btn-xs" href="/func/download/${bid | h}/${bs.get(bid).filename | h}" tooltip data-title="${_('Download this book.') | h}"><span class="glyphicon glyphicon-cloud-download"></span></a>
                    % if 'e' in a_type:
                      <button type="button" class="btn btn-danger btn-xs" tooltip data-title="${_('Delete this book.') | h}" onclick="book_delete('${bs.get(bid).name | h}', '/edit/${bid | h}/${bs.get(bid).rootpid | h}', this)"><span class="glyphicon glyphicon-trash"></span></button>
                    % endif
                  </span>
                  <a href="/edit/${bid | u}/${bs.get(bid).rootpid | h}/${lonote.im3.Paper.default_sid | h}.html">${bs.get(bid).name | h}</a>
                  <span class="small" style="font-style: italic;">(${bs.get(bid).filename | h})</span>
                </li>
              % endfor
            </ul>
          % else:
            <div class="alert alert-info">
              <p><strong>${_('Books are not exist!')}</strong></p>
              <p>${_('Please upload or create some books first') + ' ♬'}</p>
            </div>
          % endif
          % if book is not UNDEFINED:
            <div class="well">
              <a role="button" class="btn btn-primary btn-block" tooltip data-title="${_('Use this paper as root paper, and download a new book. It wasn\'t change your original book.') | h}" href="/func/download/${book.bid}/${paper.pid}/${paper.name}${lonote.im3.Book.filename_ext}"><span class="glyphicon glyphicon-filter"></span> ${_('Download Sub-book') | h}</a>
            </div>
          % endif
        </div>
      </div>
    </div>

    % if 'e' in a_type:

      <div class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-books-control-pg" data-target="#lo-books-control-create">
          <h3 class="panel-title">${_('Create a New Book')}</h3>
        </div>
        <div id="lo-books-control-create" class="panel-collapse collapse">
          <div class="panel-body">
            <form role="form" method="post" action="/func/createbook">
              <div class="form-group">
                <label for="lo-newbook-filename">${_('New Book Filename')}</label>
                <div class="input-group">
                  <input type="text" class="form-control" name="new_bid" placeholder="${_('A vaild filename for new book')}" required>
                  <span class="input-group-btn">
                    <button class="btn btn-default" type="submit">${_('Create')}</button>
                  </span>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>

      <div class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-books-control-pg" data-target="#lo-books-control-upload">
          <h3 class="panel-title">${_('Upload a Book')}</h3>
        </div>
        <div id="lo-books-control-upload" class="panel-collapse collapse">
          <div id="lo-uploadbook-body" class="panel-body">
            <form role="form" method="post" action="/func/uploadbook" enctype="multipart/form-data">
              <div class="form-group">
                <label for="lo-newbook-filename">${_('Upload File')}</label>
                <div class="input-group">
                  <input type="file" class="form-control" name="uploadfile" required multiple>
                  <span class="input-group-btn">
                    <button id="lo-uploadbook-submit" class="btn btn-default" type="submit">${_('Upload')}</button>
                  </span>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>

    % endif

  </div>

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <script>
    // 刪掉指定 url 的書，url 為 /edit/bid/pid
    function book_delete(bname, url, ethis){
      if(confirm('"'+bname+'" - ' + '${_('Really delete ?') | h}' )){
        $.ajax({
          url: url,
          type: 'DELETE',
          async: false
        }).done(function(){
            var e = $(ethis).parents('li');
            e.animate({
              opacity: '0.0',
              left: '400px',
            },
            500,
            function(){
              if(e.hasClass('lo-current-book-tag')){
                location = '/bookshelf.html'
              } else {
                e.remove();
                try{ lo_bsm_reload(); }
                catch(e){ location.reload(); } // didn't have bsm.
              }
              });
          });
      }
    };

  </script>

</%def>

<%def name="book_config_modal()">
  <div class="modal" id="lo-book-config-modal" tabindex="-1" role="dialog" aria-labelledby="lo-book-config-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-book-config-modal-title" class="modal-title">${_('Book Configure')}</h4>
        </div>
        <div id="lo-book-config-modal-body" class="modal-body">

      <form role="form">
        <div class="form-group">
          <label tooltip data-title="${_('The following text will be appended to HTML head block. If you want to try some extra style or javascript function, write something in here.')}" data-placement="auto" for="lo-appended-head">${_('Appended HTML Head')}</label>
          <%
            appended_head = ''
            try: appended_head = book.toybox.data_entity('appended.head')
            except: pass
          %>
          <textarea id="lo-appended-head" class="form-control" style="max-width: 100%; font-family: monospace;" rows="20">${appended_head}</textarea>
        </div>
      </form>

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <script>
    $(document).ready(function(){
      $('#lo-appended-head').change( function(){
        $.ajax({
          url: "/func/appended.head",
          type: "PUT",
          data: {
            appended_head: $('#lo-appended-head').val(),
            bid: "${book.bid}"
          }
        }).done(function(){location.reload(true)});
      });
    });
  </script>
</%def>

<%def name="global_config_modal()">
  <div class="modal" id="lo-global-config-modal" tabindex="-1" role="dialog" aria-labelledby="lo-global-config-modal-title" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
          <h4 id="lo-global-config-modal-title" class="modal-title">${_('Global Configure')}</h4>
        </div>
        <div id="lo-global-config-modal-body" class="modal-body">

    <div class="panel-group" id="lo-gc-pg-1">

      <div class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-gc-pg-1" data-target="#lo-gc-pg-1-go">
          <h3 class="panel-title">${_('General Options')}</h3>
        </div>
        <div id="lo-gc-pg-1-go" class="panel-collapse collapse in">
          <div class="panel-body">
            <!-- editable -->
            <div class="checkbox">
              <label tooltip data-title="${_('Toggle edit / view mode.') | h}" data-placement="auto">
                <input id="lo-editable-input" type="checkbox"> ${_('Editable Mode')}
              </label>
            </div>
          </div>
        </div>
      </div>

      <div class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-gc-pg-1" data-target="#lo-gc-pg-1-df">
          <h3 class="panel-title">${_('Datetime Format')}</h3>
        </div>
        <div id="lo-gc-pg-1-df" class="panel-collapse collapse">
          <div class="panel-body">
            <div class="form-group">
              <label for="lo-insert-time-format">${_('Insert Time Format')}</label>
              <div class="input-group">
                <input type="text" class="form-control" id="lo-insert-time-format" placeholder="${_('e.g., %H:%M:%S')}">
                <span class="input-group-addon" id="lo-insert-time-ex"></span>
              </div>
            </div>
            <div class="form-group">
              <label for="lo-insert-date-format">${_('Insert Date Format')}</label>
              <div class="input-group">
                <input type="text" class="form-control" id="lo-insert-date-format" placeholder="${_('e.g., %Y-%m-%d')}">
                <span class="input-group-addon" id="lo-insert-date-ex"></span>
              </div>
            </div>
            <p class="help-block"><small><a href="http://hacks.bluesmoon.info/strftime/demo.html" target="_blank"><span class="glyphicon glyphicon-question-sign"></span> ${_('How to Setting?')}</a></small></p>
          </div>
        </div>
      </div>

      <div id="lo-wrapper-panel" class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-gc-pg-1" data-target="#lo-gc-pg-1-wrapper">
          <h3 class="panel-title">${_('Wrapper')}</h3>
        </div>
        <div id="lo-gc-pg-1-wrapper" class="panel-collapse collapse">
          <div class="panel-body">
            <input id="lo-wrapper-input" type="text" class="form-control" placeholder="${_('set a wrapper in here.') | h}" value="" tooltip data-title="${_('Set a wrapper to bind on wrapper hotkey. e.g., "<code>{THIS}</code>"') | h}" data-placement="auto">
          </div>
        </div>
      </div>

      <div id="lo-siteinfo-panel" class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-gc-pg-1" data-target="#lo-gc-pg-1-siteinfo">
          <h3 class="panel-title">${_('Site Info')}</h3>
        </div>
        <div id="lo-gc-pg-1-siteinfo" class="panel-collapse collapse">
          <div class="panel-body">
            <div class="form-group">
              <label class="control-label" for="lo-authcode-input">${_('Site Name') | h}</label>
              <input id="lo-siteinfo-sitename-input" type="text" class="form-control" value="${config.get('SITEINFO', 'site_name')}">
            </div>
            ## <div class="form-group">
            ##   <label class="control-label" for="lo-authcode-input">${_('Site Info URL') | h}</label>
            ##   <input id="lo-siteinfo-siteinfourl-input" type="text" class="form-control" placeholder="${_('A web page to describe this site') | h}" value="${config.get('SITEINFO', 'site_info_url')}">
            ## </div>
            <div class="form-group">
              <button id="lo-siteinfo-update-btn" class="btn btn-primary" type="submit">${_('Update')}</button>
            </div>
          </div>
        </div>
      </div>

      <div id="lo-closereset-panel" class="panel panel-default">
        <div class="panel-heading" style="cursor: pointer;" data-toggle="collapse" data-parent="#lo-gc-pg-1" data-target="#lo-gc-pg-1-closereset">
          <h3 class="panel-title">${_('Close & Reset')}</h3>
        </div>
        <div id="lo-gc-pg-1-closereset" class="panel-collapse collapse">
          <div class="panel-body">
            <p>
              <button id="lo-resetbrowser" class="btn btn-warning btn-lg" type="submit" tooltip data-title="${_('Reset all browser side data. It include page scroll, datetime format, resource insert format. etc.')}" data-placement="auto" data-container="#lo-closereset-panel"><span class="glyphicon glyphicon-wrench"></span> ${_('Reset Browser')}</button>
              <button id='lo-shutdown' class="btn btn-danger btn-lg" type="submit" tooltip data-title="${_('Shutdown server right now! You cannot re-open server by browser, so be careful.')}" data-placement="auto" data-container="#lo-closereset-panel"><span class="glyphicon glyphicon-off"></span> ${_('Shutdown Server')}</button>
            </p>
            <p>
              <button type="button" id="lo-search-update" class="btn btn-primary btn-lg" tooltip data-title="${_('manual update the search index') | h}" data-container="#lo-closereset-panel" data-placement="right"><span class="glyphicon glyphicon-refresh"></span> ${_('Update Search Index')}</button>
            </p>
          </div>
        </div>
      </div>

    </div>

        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">${_('Close')}</button>
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->

  <script>
    function deleteAllCookies() {
      var cookies = document.cookie.split(";");

      for (var i = 0; i < cookies.length; i++) {
        var cookie = cookies[i];
        var eqPos = cookie.indexOf("=");
        var name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
        document.cookie = name + "=;path=/;expires=Thu, 01 Jan 1970 00:00:00 GMT";
      }
    };
    $('#lo-resetbrowser').on('click', function(){
      var ans = confirm('${_("Really reset your browser?") | h}');
      if(ans){
        localStorage.clear();
        deleteAllCookies();
        location.reload();
      }
    });
    $('#lo-shutdown').on('click', function(){
      function complete(){location.reload();};
      var ans = confirm('${_("Really shutdown LoNote Server?") | h}');
      if(ans){
        try{
          $.ajax({
            url: '/func/shutdown',
            type: 'POST',
            async: false
            }).always(complete)
        } catch(e){
          complete();
        }
      }
    });
    function index_update_request_sync(){
      $.ajax({
        url: '/func/index-update?sync=1',
        type: 'POST',
        async: false
      });
    };
    $('#lo-search-update').on('click', function(){
      index_update_request_sync();});

    $('#lo-siteinfo-update-btn').on('click', function(){
      function complete(){location = '/';};
      try{
        var data = {
          site_name: $('#lo-siteinfo-sitename-input').val(),
          // site_info_url: $('#lo-siteinfo-siteinfourl-input').val(),
          };
        $.ajax({
          url: '/func/site-info',
          type: 'PUT',
          data: data,
          async: false
          }).always(complete)
      } catch(e){
        complete();
      }
    });

    // editable
    var uri = new URI(location.pathname);
    var uri_type = uri.segment(0);
    var input = $('#lo-editable-input');
    function lo_editable_trigger(){
      if(uri_type == 'edit'){ // avoid trigger in non-edit pages
        if ( input.is(':checked') ){
          $('#lo-article-content').prop('contenteditable', true);
        } else {
          $('#lo-article-content').prop('contenteditable', false);
        }
      }
    };
    function lo_editable_set(){
      $(document).ready( function(){
        input.change(lo_editable_trigger);
        editable = localStorage['lo_editable']
        if (editable == 'true'){
          input.prop('checked', true)
          lo_editable_trigger();
        } else if (editable == undefined) {
          input.prop('checked', true)
          lo_editable_trigger();
        }
        $(window).on('beforeunload', function(){
          localStorage['lo_editable'] = input.is(':checked')
        });
        shortcut.add('F10',function() {
          input.click();
        });
      });
    };

    % if 'e' in a_type:
      lo_editable_set();
    % endif

    $(document).ready(function(){
      try{
        var fmt = localStorage['time_insert_format'];
        $('#lo-insert-time-format').val(fmt);
        var d = new Date();
        $('#lo-insert-time-ex').text(d.strftime(fmt));
      } catch(e) {}
      try{
        var fmt = localStorage['date_insert_format'];
        $('#lo-insert-date-format').val(fmt);
        var d = new Date();
        $('#lo-insert-date-ex').text(d.strftime(fmt));
      } catch(e) {}

      $('#lo-insert-time-format').on('change', function(){
        var fmt = $('#lo-insert-time-format').val();
        localStorage['time_insert_format'] = fmt;
        var d = new Date();
        $('#lo-insert-time-ex').text(d.strftime(fmt));
      });
      $('#lo-insert-date-format').on('change', function(){
        var fmt = $('#lo-insert-date-format').val();
        localStorage['date_insert_format'] = fmt;
        var d = new Date();
        $('#lo-insert-date-ex').text(d.strftime(fmt));
      });

      // wrapper 設定
      var wrapper_fmt = localStorage['wrapper'];
      if(wrapper_fmt == undefined || wrapper_fmt == null || wrapper_fmt == '') {
        wrapper_fmt = '<code>{THIS}</code>';
      }
      $('#lo-wrapper-input').val(wrapper_fmt);
      $('#lo-wrapper-input').on('change', function(){
        localStorage['wrapper'] = $('#lo-wrapper-input').val();
      });

      shortcut.add('Alt+Z',function() {
        var wrapper = $('#lo-wrapper-input').val();
        if (wrapper != ''){
          var selHtml = rangy.getSelection().toHtml();
          var html = wrapper.replace(/{THIS}/gi, selHtml);
          document.execCommand("insertHTML", false, html);
        }
      });
    });
  </script>
</%def>

<%def name="btn_configure_paper()">
  <div class="btn-group">
    <button type="button" class="btn btn-default dropdown-toggle" tooltip data-title="${_('Others') | h}" data-placement="bottom" data-container="body" data-toggle="dropdown"><span class="glyphicon glyphicon-cog"></span></button>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      <li tooltip data-title="${_('Manage the resources of this paper.') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-resource-modal"><span class="glyphicon glyphicon-inbox"></span> ${_('Resources Management') | h}</a></li>
      <li class="divider"></li>
      % if 'e' in a_type:
        ${configure_menu_newpaper_item()}
        <li tooltip data-title="${_('Misc setting for this book') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-book-config-modal"><span class="glyphicon glyphicon-wrench"></span> ${_('Book Configure') | h}</a></li>
        <li class="divider"></li>
        <li tooltip data-title="${_('Re-order papers') | h}" data-placement="left" data-container="body"><a href="/bookshelf.html"><span class="glyphicon glyphicon-move"></span> ${_('Move Papers') | h}</a></li>
        <li class="divider"></li>
      % endif
      <li tooltip data-title="${_('Let\'s create, upload, download, and delete some books.') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-books-control-modal"><span class="glyphicon glyphicon-book"></span> ${_('Books Management') | h}</a></li>
      % if 'e' in a_type:
        <li tooltip data-title="${_('Misc setting for global') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-global-config-modal"><span class="glyphicon glyphicon-cog"></span> ${_('Global Configure') | h}</a></li>
      % endif
      <li tooltip data-title="${_('Change current access level.') | h}" data-placement="left" data-container="body"><a href="/permission.html"><span class="glyphicon glyphicon-certificate"></span> ${_('Permission Control') | h}</a></li>
      <li class="divider"></li>
      <li tooltip data-title="${_('Back to start page, get recent pages and help.') | h}" data-placement="left" data-container="body"><a href="/start.html"><span class="glyphicon glyphicon-info-sign"></span> ${_('Start Page') | h}</a></li>
    </ul>
  </div>
</%def>

<%def name="modal_configure_paper()">
  ${configure_menu_newpaper_script()}
  ${books_control_modal()}
  ${book_config_modal()}
  ${global_config_modal()}
  ${modal_resource()}
</%def>


<%def name="btn_configure_start()">
  <div class="btn-group">
    <button type="button" class="btn btn-default dropdown-toggle" tooltip data-title="${_('Others') | h}" data-placement="bottom" data-container="body" data-toggle="dropdown"><span class="glyphicon glyphicon-cog"></span></button>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      % if 'e' in a_type:
        <li tooltip data-title="${_('Re-order papers') | h}" data-placement="left" data-container="body"><a href="/bookshelf.html"><span class="glyphicon glyphicon-move"></span> ${_('Move Papers') | h}</a></li>
        <li class="divider"></li>
      % endif
      <li tooltip data-title="${_('Let\'s create, upload, download, and delete some books.') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-books-control-modal"><span class="glyphicon glyphicon-book"></span> ${_('Books Management') | h}</a></li>
      % if 'e' in a_type:
        <li tooltip data-title="${_('Misc setting for all page') | h}" data-placement="left" data-container="body"><a data-toggle="modal" href="#lo-global-config-modal"><span class="glyphicon glyphicon-cog"></span> ${_('Global Configure') | h}</a></li>
      % endif
      <li tooltip data-title="${_('Change current access level.') | h}" data-placement="left" data-container="body"><a href="/permission.html"><span class="glyphicon glyphicon-certificate"></span> ${_('Permission Control') | h}</a></li>
      <li class="divider"></li>
      <li tooltip data-title="${_('Check LoNote server modified history.') | h}" data-placement="left" data-container="body"><a href="/logging.txt" target="_blank"><span class="glyphicon glyphicon-list-alt"></span> ${_('Logging Page') | h}</a></li>
    </ul>
  </div>
</%def>

<%def name="modal_configure_start()">
  ${books_control_modal()}
  ${global_config_modal()}
</%def>
