<%!
  from lonote.im3 import Paper
%>

<%inherit file="base.mako"/>
<%page args="book, paper, sid"/>

<%block name="lo_head_title">
  ${paper.name | h}
  % if sid != Paper.default_sid:
    (${sid | h})
  % endif
  ## - ${book.name | h}
</%block>

<%block name="lo_head_script"/>

<%block name="lo_head_append">
  <%
    appended_head = ''
    try: appended_head = book.toybox.data_entity('appended.head')
    except: pass
  %>
  ${appended_head}

  <style>
    #lo-article { padding-top: 0px; }
  </style>
</%block>

<%block name="lo_aside"/>

<%block name="lo_article_content">
  ${paper.sections.data_entity(sid)}

  <%
    att_rids = [ rid for rid in paper.resources.ids
        if paper.resources.data_meta(rid).get('res_type') == 'att' ]
    att_rids.sort()
  %>
  % if att_rids:
    <br/>
    <div class="row">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">
            <h1 class="panel-title">${_('Attachment') | h}</h1>
          </div>
          <div class="panel-body">
            <div class="list-group" style="font-weight: bold;">
              % for rid in att_rids:
              <a class="list-group-item" href="${rid}"><span class="label label-warning"><span class="glyphicon glyphicon-download"></span></span> - ${rid}</a>
              % endfor
            </ul>
          </div>
        </div>
      </div>
    </div>
  % endif
</%block>

<%block name="lo_article_footer">
  ## <footer id="lo-article-footer" class="text-center">
  ##   - <a href="${info.homepage | h}">${_('LoNote Personal Notebook') | h}</a> ${info.version | h} -
  ## </footer>
</%block>

<%block name="lo_base_script"/>
